//---     
#include "..\MultiSymbolPendingOrders.mq5"
//---   
#include "Enums.mqh"
#include "Errors.mqh"
#include "TradeSignals.mqh"
#include "TradeFunctions.mqh"
#include "ToString.mqh"
#include "Auxiliary.mqh"
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void GetSymbols()
  {
   Symbols[0]=GetSymbolByName(Symbol_01);
   Symbols[1]=GetSymbolByName(Symbol_02);
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
void GetTimeRangeTrade()
  {
   TradeInTimeRange[0]=TradeInTimeRange_01;
   TradeInTimeRange[1]=TradeInTimeRange_02;
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void GetStartTrade()
  {
   StartTrade[0]=StartTrade_01;
   StartTrade[1]=StartTrade_02;
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
void GetStopEntryTrade()
  {
   StopOpenOrders[0]=StopOpenOrders_01;
   StopOpenOrders[1]=StopOpenOrders_02;
  }
//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+
void GetEndTrade()
  {
   EndTrade[0]=EndTrade_01;
   EndTrade[1]=EndTrade_02;
  }
//+------------------------------------------------------------------+
//|   Pending Order                                   |
//+------------------------------------------------------------------+
void GetPendingOrder()
  {
   PendingOrder[0]=PendingOrder_01;
   PendingOrder[1]=PendingOrder_02;
  }
//+------------------------------------------------------------------+
//|   Take Profit                                     |
//+------------------------------------------------------------------+
void GetTakeProfit()
  {
   TakeProfit[0]=TakeProfit_01;
   TakeProfit[1]=TakeProfit_02;
  }
//+------------------------------------------------------------------+
//|   Stop Loss                                       |
//+------------------------------------------------------------------+
void GetStopLoss()
  {
   StopLoss[0]=StopLoss_01;
   StopLoss[1]=StopLoss_02;
  }
//+------------------------------------------------------------------+
//|   Trailing Stop                                   |
//+------------------------------------------------------------------+
void GetTrailingStop()
  {
   TrailingStop[0]=TrailingStop_01;
   TrailingStop[1]=TrailingStop_02;
  }
//+------------------------------------------------------------------+
//|   Reverse                                         |
//+------------------------------------------------------------------+
void GetReverse()
  {
   Reverse[0]=Reverse_01;
   Reverse[1]=Reverse_02;
  }
//+------------------------------------------------------------------+
//|   Lot                                             |
//+------------------------------------------------------------------+
void GetLot()
  {
   Lot[0]=Lot_01;
   Lot[1]=Lot_02;
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void InitializeNewBarArray()
  {
//---  
   ArrayInitialize(new_bar,0);
//---
   for(int s=0; s<NUMBER_OF_SYMBOLS; s++)
     {
      //---      
      if(Symbols[s]!="")
         //---    
         CheckNewBar(s);
     }
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
void InitializeLastDealTicketsArray()
  {
//---  
   ArrayInitialize(last_deal_ticket,0);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
void InitializeHandlesArray()
  {
   ArrayInitialize(spy_indicator_handles,INVALID_HANDLE);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void InitializeInputParameters()
  {
   GetSymbols();
   GetTimeRangeTrade();
   GetStartTrade();
   GetStopEntryTrade();
   GetEndTrade();
   GetPendingOrder();
   GetTakeProfit();
   GetStopLoss();
   GetTrailingStop();
   GetReverse();
   GetLot();
  }
//+------------------------------------------------------------------+
//|      " "                  |
//+------------------------------------------------------------------+
string GetSymbolByName(string symbol)
  {
   string symbol_name="";   //    
//---    ,   
   if(symbol=="")
      return("");
//---       
   for(int s=0; s<SymbolsTotal(false); s++)
     {
      //---   
      symbol_name=SymbolName(s,false);
      //---      
      if(symbol==symbol_name)
        {
         //---     " "
         SymbolSelect(symbol,true);
         //---   
         return(symbol);
        }
     }
//---    ,   
   Print("C "+symbol+"    !");
   return("");
  }
//+------------------------------------------------------------------+
